using namespace std;
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define ll long long
typedef tree<int, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> inv;
#define pb push_back
#define eb emplace_back
#define endl "\n"
#define ld long double
#define vl __int128_t
struct segtree {
    vector<ll> tree;
    segtree(const vector<ll> & h) {
        ll n = (ll)h.size();
        ll lg = ceil(log2(n));
        n = 1 << lg;
        tree.resize(n * 2);
        build(0, 0, n, h);
    }
    void build(ll v, ll l, ll r, const vector<ll> & h) {
        if (l == r - 1) {
            tree[v] = h[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v + 1, l, mid, h);
        build(2 * v + 2, mid, r, h);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    void update(ll v, ll l, ll r, ll x, ll i) {
        if (l == r - 1) {
            tree[v] = x;
            return;
        }
        ll mid = (l + r) / 2;
        if (i < mid) {
            update(2 * v + 1, l, mid, x, i);
        } else {
            update(2 * v + 2, mid, r, x, i);
        }
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql >= r || qr <= l) {
            return 0ll;
        }
        if (ql <= l && qr >= r) {
            return tree[v];
        }
        ll mid = (l + r) / 2;
        return max(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
    }
    void out() {
        for (ll i : tree) cout << i << " ";
        cout << endl;
    }
};
int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll n;
    cin >> n;
    vector<ll> h(n);
    for (int i = 0; i < n; ++i) {cin >> h[i];}
    segtree st(h);
    vector<pair<ll, ll>> qs;
    for (int i = 0; i < n; ++i) {
        qs.pb({i, i + 1});
    }
    for (int _ = 0; _ < n - 1; ++_) {
        ll ki;
        cin >> ki;
        qs[ki - 1].second = qs[ki].second;
        qs.erase(qs.begin() + ki);
        ll s = 0;
        for (ll i = qs[ki - 1].first; i < qs[ki - 1].second; ++i) {
            //ll ml = st.get(0, 0, n, qs[ki - 1].first, i + 1);
            //ll mr = st.get(0, 0, n, i, qs[ki - 1].second);
            ll ml = 0, mr = 0;
            for (int j = qs[ki - 1].first; j <= i; ++j) {
                ml = max(ml, h[j]);
            }
            for (int j = i; j < qs[ki - 1].second; ++j) {
                mr = max(mr, h[j]);
            }
            s += min(ml, mr) - h[i];
        }
        cout << s << endl;
    }
}