using namespace std;
#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl __int128_t
#define pb push_back
#define endl "\n"
const ll mod = 1000000007;
const ll MAX = 1e9 + 52;
struct segtree {
    vector<ll> tree;
    segtree(vector<ll> & a) {
        int n = int(a.size());
        tree.resize(n * 4, MAX);
        build(0, 0, n, a);
    }
    void build(ll v, ll l, ll r, vector<ll> & a) {
        if (l == r - 1) {
            tree[v] = a[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql >= r || qr <= l) {
            return MAX;
        } else if (ql <= l && qr >= r) {
            return tree[v];
        }
        ll mid = (l + r) / 2;
        return min(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
    }
    void out() {
        for (ll i : tree) cout << i << " ";
        cout << endl;
    }
};
const ll mxN = 100007;
vector<pair<ll, ll>> path;
ll n, s;
vector<pair<ll, ll>> subtasks;
map<pair<ll, ll>, ll> d;
void rec(ll ind) {
    if (s == 0) {
        vector<bool> c(n, 0);
        for (pair<ll, ll> i : path) {
            c[i.second] = true;
        }
        for (bool i : c) {
            if (!i) {
                return;
            }
        }
        cout << "Yes" << endl;
        vector<vector<ll>> ans(n);
        for (pair<ll, ll> i : path) {
            ans[i.second].pb(i.first);
        }
        for (int _ = 0; _ < n; ++_) {
            vector<ll> i = ans[_];
            cout << i.size() << endl;
            for (ll j : i) {
                cout << d[{j, _}] + 1 << " ";
            }
            cout << endl;
        }
        exit(0);
    }
    if (ind == n) {
        return;
    }
    s -= subtasks[ind].first;
    path.pb(subtasks[ind]);
    rec(ind + 1);
    path.resize(path.size() - 1);
    s += subtasks[ind].first;
    rec(ind + 1);
}
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ki, cij;
    cin >> n >> s;
    for (int i = 0; i < n; ++i) {
        cin >> ki;
        for (int j = 0; j < ki; ++j) {
            cin >> cij;
            subtasks.pb({cij, i});
            d[{cij, i}] = j;
        }
    }
    // subtasks.size() = 100000
    rec(0);
    cout << "No";
}