using namespace std;
#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl __int128_t
#define pb push_back
#define endl "\n"
const ll mod = 1000000007;
struct segtree {
    vector<ll> tree;
    segtree(vector<ll> & a) {
        int n = int(a.size());
        tree.resize(n * 4);
        build(0, 0, n, a);
    }
    void build(ll v, ll l, ll r, vector<ll> & a) {
        if (l == r - 1) {
            tree[v] = a[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql >= r || qr <= l) {
            return LLONG_MAX;
        } else if (ql <= l && qr >= r) {
            return tree[v];
        }
        ll mid = (l + r) / 2;
        return min(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
    }
    void out() {
        for (ll i : tree) cout << i << " ";
        cout << endl;
    }
};
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll n, k;
    cin >> n >> k;
    ll npr = n, lg = ceil(log2(n));
    n = 1 << lg;
    vector<ll> a(n), pref(n + 1, 0);
    for (int i = 0; i < npr; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    segtree st(a);
    ll max_sum = 0;
    for (int i = 0; i < k; ++i) {
        ll curr = pref[i + npr - k + 1] - pref[i];
        ll mi = st.get(0, 0, n, 0, i);
        if (i + n - k + 1 < npr) {
            mi = min(st.get(0, 0, n, i + n - k + 1, n), mi);
        }
        max_sum = max(max_sum, curr - mi);
    }
    cout << max_sum;
}