using namespace std;
#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl __int128_t
#define pb push_back
#define endl "\n"
const ll mod = 1000000007;
const ll MAX = LLONG_MAX;
struct segtree {
    vector<ll> tree;
    segtree(vector<ll> & a) {
        int n = int(a.size());
        tree.resize(n * 4, MAX);
        build(0, 0, n, a);
    }
    void build(ll v, ll l, ll r, vector<ll> & a) {
        if (l == r - 1) {
            tree[v] = a[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql >= r || qr <= l) {
            return MAX;
        } else if (ql <= l && qr >= r) {
            return tree[v];
        }
        ll mid = (l + r) / 2;
        return min(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
    }
    void out() {
        for (ll i : tree) cout << i << " ";
        cout << endl;
    }
};
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n, MAX), pref(n + 1, 0), pref_min(n + 1, MAX), suff_min(n + 1, MAX);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
        pref_min[i + 1] = min(pref_min[i], a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        suff_min[i] = min(suff_min[i + 1], a[i]);
    }
    ll max_sum = 0;
    for (int i = 0; i < k; ++i) {
        ll curr = pref[i + n - k + 1] - pref[i];
        ll mi = min(pref_min[i], suff_min[i + n - k + 1]);
        max_sum = max(max_sum, curr - mi);
    }
    cout << max_sum;
}